-- © Riccardo Di Meo 2015
opengl          = require "opengl"
misc_options    = require "options"

-- Must be a global function (used by java)
-- TODO/FIXME Not DRY: app_debug.lua, baseconfig.lua, entry_point.lua :(
function findObject(path)
   local res, value = pcall(
      function()
         return load("return " .. path)()
      end
   )
   return {
      success = res,
      value = value
   }
end

function current_memory_used()
   return math.floor(collectgarbage("count") * 1024)
end

function garbage_collect()
   local old = collectgarbage("count")
   collectgarbage("collect")
   local new = collectgarbage("count")
   return math.floor((old - new) * 1024)
end

-- todo/fixme: move somewhere else
splashscreen_interval = 2000  -- permanence of the splash scren in milliseconds. Integer
fileselector_finishes = false  -- whether the cardboard activity will "back" to the fileselector or not
function create_scene_with_parameters(parameters)
   local scene        = require "scene/scene"
   current = scene.create_scene_with_parameters(parameters)
   -- this should lower the memory consumption: unloading the scripts will also unload 
   -- most of the data
   package.loaded.scene = nil
   package.loaded.scene_common = nil
   package.loaded.panoramic = nil
   collectgarbage("collect")
end

function dispose_current_scene() 
   -- TODO/FIXME: JUST REMOVE THE OPENGL STUFF, IF THE CASE...
   --current = nil -- THIS CANNOT BE DONE, OTHERWISE THE CONTROLS WILL STOP WORKING!
   collectgarbage("collect")
end
