local consts = require "scene/scene_constants"

local FIRST_PANEL_ENTITIES = {
    [consts.PREV_TRACK] = true,
    [consts.FAST_BACKWARD] = true,
    [consts.VOLUME_UP] = true,
    [consts.VOLUME_DOWN] = true,
    [consts.BACKWARD] = true,
    [consts.PAUSE] = true,
    [consts.FORWARD] = true,
    [consts.ALIGN] = true,
    [consts.FAST_FORWARD] = true,
    [consts.NEXT_TRACK] = true,
}

local SECOND_PANEL_ENTITIES = {
    [consts.INVERT_3D] = true,
    [consts.LOCK_THEATER] = true,
    [consts.MOVE_FORWARD] = true,
    [consts.MOVE_BACKWARD] = true,
    [consts.MOVE_UP] = true,
    [consts.MOVE_DOWN] = true,
    [consts.ZOOM_IN] = true,
    [consts.ZOOM_OUT] = true,
    [consts.RESET_ZOOM] = true,
    [consts.SCREEN_TYPE] = true,
    [consts.SCREEN_RATIO] = true,
    [consts.STEREO_TYPE] = true,
}

local EXTRA_ENTITIES = {
    [consts.CONTROLS_PANEL] = true,
    [consts.CONTROLS_BUTTON] = true,
    [consts.CONTROLS_SWITCH] = true,
}

-- TODO/FIXME: this naked variable is hideous
local current_controls_set = FIRST_PANEL_ENTITIES

local is_a_control = function(name)
   return FIRST_PANEL_ENTITIES[name] ~= nil
      or EXTRA_ENTITIES[name] ~= nil
      or SECOND_PANEL_ENTITIES[name] ~= nil
end

local function get(name)
   return current_controls_set[name]
end

local function set_first_panel()
   current_controls_set = FIRST_PANEL_ENTITIES
end

local function set_second_panel()
   current_controls_set = SECOND_PANEL_ENTITIES
end

local function switch_controls_panel()
   if current_controls_set == FIRST_PANEL_ENTITIES then
      set_second_panel()
   else
      set_first_panel()
   end
end

return {
   is_a_control = is_a_control,
   get = get,
   set_first_panel = set_first_panel,
   set_second_panel = set_second_panel,
   switch_controls_panel = switch_controls_panel,
}
