-- Created by Riccardo Di Meo
-- © Riccardo Di Meo 2015
local consts = require "scene/scene_constants"
local options = require "options"

--- Screen creation functions
local function get_169_screen()
    local width = options.room_width * 0.8
    local height = width * 9.0 / 16.0
    local lift = height * 0.5 + 3.0
    return {
        width = width,
        height = height,
        lift = lift,
        ratio = 16.0 / 9
    }
end

local function get_2391_screen()
    local width = options.room_width * 0.8
    local height = width / 2.39
    local lift = options.room_height * 0.5
    return {
        width = width,
        height = height,
        lift = lift,
        ratio = 2.39
    }
end

local function get_1610_screen()
    local width = options.room_width * 0.8
    local height = width * 10.0 / 16.0
    local lift = height * 0.5 + 2.4
    return {
        width = width,
        height = height,
        lift = lift,
        ratio = 16.0 / 10
    }
end

local function get_916_screen()
    local height = options.room_height * 0.9
    local width = height * 9.0 / 16.0
    local lift = height * 0.5 + options.room_height * 0.05 
    return {
        width = width,
        height = height,
        lift = lift,
        ratio = 9.0 / 16
    }
end

local function get_43_screen()
    local width = options.room_width * 0.6
    local height = width * 3.0 / 4.0
    local lift = height * 0.5 + 2.5
    return {
        width = width,
        height = height,
        lift = lift,
        ratio = 4.0 / 3
    }
end

local function get_right_screenmodel(ratio)
    local avail = {
        { get_916_screen, 9.0 / 16.0, consts.ARATIO_9_16 },
        { get_43_screen, 4.0 / 3.0, consts.ARATIO_4_3 },
        { get_169_screen, 16.0 / 9.0, consts.ARATIO_16_9 },
        { get_1610_screen, 16.0 / 10.0, consts.ARATIO_16_10 },
        { get_2391_screen, 2.39, consts.ARATIO_2_39_1 }
    }
    local best_result = math.abs(avail[1][2] - ratio)
    local best_function = 1
    for idx in ipairs(avail) do
        local res = math.abs(avail[idx][2] - ratio)
        if (res <= best_result) then
            best_result = res
            best_function = avail[idx][1]
        end
    end
    return best_function()
end

return {
    get_right_screenmodel = get_right_screenmodel
}
