#version 300 es
precision mediump float;

in vec2 fuv;

out vec4 frag_color;

uniform int id;
uniform int activated;
uniform sampler2D normal_icon;
uniform sampler2D over_icon;
uniform float controls_opacity;

uniform int feedback_rendering;

void main() {
  vec4 texvalue;
  if(activated == 1) {
    texvalue = texture(over_icon, fuv);
  } else {
    texvalue = texture(normal_icon, fuv);    
  }
  
  if(texvalue.a == 0.0) {
    discard;
  } else {
    if(feedback_rendering == 1) {
      frag_color = vec4(float(id) / 255.0, 0.0, 0.0, 1.0);
    } else {
      float mult = texvalue.r * min(controls_opacity + float(activated), 1.0);
      frag_color = vec4(float(activated), 0.0, (1.0 - float(activated)), mult);
    }
  }
}
