#version 300 es

in vec3 pos;

uniform highp mat4 modelview;
uniform mat4 projection;
uniform float yaw;

out vec3 fpos;

mat3 rotate(float yaw) {
  float c = cos(yaw);
  float s = sin(yaw);
  return mat3(c, 0, s, 0, 1, 0, -s, 0, c);
}

void main() {	
  vec4 tmp = modelview * vec4(-pos.x, pos.y, pos.z, 1.0);
  fpos = rotate(yaw) * pos;
  gl_Position = projection  * tmp;
}
