#version 300 es
precision mediump float;

in vec2 fuv;

out vec4 frag_color;

uniform sampler2D image;
uniform float alpha;

void main() {
  vec4 texvalue = texture(image, fuv);
  float endalpha = alpha * texvalue.a;
  // discard transparent pixels, show the black ones as transparent
  if(endalpha == 0.0) {
    discard;
  } else {
    float color = texvalue.r;
    frag_color = vec4(color, color, color, endalpha);
  }
}
