// This code should be loaded after a *_conversion.vert shader block

attribute vec3 pos;
attribute vec2 uv;

varying vec2 tuv;
varying vec4 cid;
varying mat3 color_conversion;

uniform mat4 modelview;
uniform mat4 projection;
uniform int eye;
uniform int id;
uniform mat3 swizzle_left, swizzle_right;
		    
void main() {
  color_conversion = float(eye) * swizzle_left + float(1 - eye) * swizzle_right;

  cid = vec4(float(id) / 255.0, 0.0, 0.0, 1.0);
	
  tuv = getRightUV(uv, eye);
  // This dirty trick is used to prevent eye to be optimized out in 2D rendering
  tuv = tuv * abs(float(eye) - 0.5) * 2.0;
  gl_Position = projection * modelview * vec4(pos, 1.0);
}
