#version 100
#extension GL_OES_EGL_image_external :require
precision mediump float;

varying vec2 tuv;

uniform samplerExternalOES video;
uniform int feedback_rendering;
uniform float brightness;
uniform float contrast;

varying vec4 cid;

vec3 correct_brightness(vec3 color) {
  return color + brightness;
}

vec3 correct_contrast(vec3 color) {
  return contrast * (color - vec3(0.5)) + vec3(0.5);
}

void main() {
  if(feedback_rendering == 1) {
    gl_FragColor = cid;
  } else {  
    vec3 texvalue = texture2D(video, tuv).rgb;
    gl_FragColor = vec4(correct_contrast(correct_brightness(texvalue)), 1.0);
  }
}
