#version 300 es
precision mediump float;

in vec2 tuv;
out vec4 frag_color;

uniform sampler2D prevideo;
uniform int feedback_rendering;
uniform float brightness;
uniform float contrast;

flat in vec4 cid;

vec3 correct_brightness(vec3 color) {
  return color + brightness;
}

vec3 correct_contrast(vec3 color) {
  return contrast * (color - vec3(0.5)) + vec3(0.5);
}

void main() {
  if(feedback_rendering == 1) {
    frag_color = cid;
  } else {  
    vec3 texvalue = texture(prevideo, tuv).rgb;
    frag_color = vec4(correct_contrast(correct_brightness(texvalue)), 1.0);// + vec4(1.0, 1.0, 1.0, 1.0);
  }
}
