#version 300 es

in vec3 pos;
in vec2 uv;

uniform highp mat4 modelview;
uniform highp mat4 model;
uniform mat4 projection;
uniform vec2 uvscale;
uniform vec2 uvoffset;
uniform vec4 lightpos;
uniform vec3 lightanimpar;
uniform vec2 lightrange;
uniform mat4 view;
uniform int time;
//uniform sampler2D prevideo;

out vec2 fuv;
out vec4 uV;
out vec4 uLp;

vec4 correctedLightPos(vec4 oldpos, vec4 position) {
  return vec4(clamp(position.x / position.w, lightrange.x, lightrange.y), oldpos.y, oldpos.z, oldpos.w);
}

vec4 lightposmod() {
  float angle = 2.0 * 3.1415 * float(time) / lightanimpar[2];
  return lightpos + vec4(lightanimpar[0] * cos(angle), 0.0, lightanimpar[1] * sin (angle), 0.0);
}

void main() {	
  fuv = uv * uvscale + uvoffset;
  uV = modelview * vec4(pos, 1.0);

  // perspective correction and normalization required? I don't think so...
  uLp = view * correctedLightPos(lightposmod(), model * vec4(pos, 1.0));

  gl_Position = projection  * uV;
}
